// FILENAME:	CTF_Cybrid_Core.cs
//
// AUTHOR:		Gen. Raven [M.I.B.]
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetectOnAdd = false;
$stealthDetectOnRemove = true;  //Ancients has none when a player leaves

//------------------------------------------------------------------------------
$missionName = "CTF_Cybrid_Core";

$downloadSite = "www.starsiegemeninblack.cjb.net or www.ravenmib.cjb.net";  

$maxFlagCount  = 8;           // no of flags required by a team to end the game
$flagValue     = 5;          // points your team gets for capturing
$carrierValue  = 2;          //  "      "    "    "    " killing carrier
$killPoints    = 1;
$deathPoints   = 1;
$flagTime = 180;

exec("multiplayerStdLib.cs");
exec("CTFstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	plutoSounds();

	$soundLow = getObjectId("Missiongroup\\AmbientStuff\\soundLow");
	$soundHigh = getObjectId("Missiongroup\\AmbientStuff\\soundHigh");
	$rock = getObjectId("Missiongroup\\AmbientStuff\\rock");

	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_industrial.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_electrical_bzzt.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_electrical_bzzt.wav", IDPRF_FIRE, $soundHigh); 
	playSound(0, "sfx_cybrid_indust.wav", IDPRF_FIRE, $soundLow); 
	playSound(0, "sfx_cybrid_indust.wav", IDPRF_FIRE, $soundHigh); 

	schedule("splodinStuff();",30);
     

	//CTF
      initGlobalVars();
}

function onMissionLoad()
{
   cdAudioCycle("Cyberntx", "YouGot", "Terror", "Mechsoul", "NewTech"); 
   %count = playermanager::getPlayerCount();
   if(%count >= 5)
   {
      say(0, 5, "Welcome to CTF Cybrid Core! You can download this & other missions made by Gen. Raven [M.I.B.] at "@$downloadSite@".");
   }
}

function player::onAdd(%player)
{
   if(($stealthDetectOnAdd == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
   say(%player, 0, "Welcome to CTF Cybrid Core! You can download this & other missions made by Gen. Raven [M.I.B.] at "@$downloadSite@".");

   //Activate Rock's Admin Pack if its being used
   RocksPlayerOnAdd(%player);
}

function player::onRemove(%player)
{
   if(($stealthDetectOnRemove == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}

function ravensTransport(%vehicleId,%x1,%y1,%x2,%y2)
{
   %x = randomInt(%x1,%x2);
   %y = randomInt(%y1,%y2);
   %z = -235;
   setPosition(%vehicleId,%x,%y,%z);
}

function blueTeleport::trigger::onEnter(%trigger, %vehicleId)
{
   ravensTransport(%vehicleId,767,-2309,804,-2250);
}

function purpleTeleport::trigger::onEnter(%trigger, %vehicleId)
{
   ravensTransport(%vehicleId,-1076,-1270,-1025,-1224);
}

function coreFlash::trigger::onContact(%trigger,%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   fadeEvent(%player, in, 2, 0.4, 0.6, 1);
}

function coreBoom::trigger::onContact(%trigger,%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   fadeEvent(%player, in, 4, 0.4, 0.6, 1);
   healObject(%vehicleId,-99999);
   say(0,0,"<f5><<CORE-NEXUS>: Core\\\\reactor breach detected. Human\\\\animal attempted to impede//disrupt energy flow. ERROR has been >>purged//removed<<.");
}

function kill::trigger::onContact(%trigger,%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   healObject(%vehicleId,-99999);
   messageBox(%player,"You were killed for going out of bounds.");
}

function copyObject(%object,%name)
{
   storeObject(%object, "copyObject.tmp");
   if(%name=="")
   {
      %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   }
   else
   {
      %copy = loadObject(%name, "copyObject.tmp");
   }
   return %copy;
}

function splodinStuff()
{
   %x = randomInt(-1666,810);
   %y = randomInt(-1973,-1004);
   %z = -70;
   %copy = copyObject($rock);
   setposition(%copy,%x,%y,%z);
   schedule("damageObject("@%copy@",99999);",0.1);
   schedule("deleteObject("@%copy@");",0.3);
   schedule("splodinStuff();",30);
}

function onMissionEnd()
{
   flushConsoleScheduler();
}
